Moodul 5 · 5.2
Kalendri ja kontaktide eksportimine Google'ist ja Microsoftist
Moodul 5: Kalender ja kontaktid · Lugemisaeg: 12 minutit
Õpieesmärk: Pärast seda tundi oskad teha täielikku ja kasutatavat eksporti kalendritest ja kontaktidest Google'ist ja Microsoftist, lugeda ICS- ja vCard-faili ning tead, mis eksportimisel kaasa ei tule või teisiti käitub.
Põhimõisted: iCalendar (ICS), VCALENDAR, VEVENT, UID, DTSTART, RRULE, EXDATE, VTIMEZONE ja TZID, ORGANIZER ja ATTENDEE, VALARM, vCard (VCF) 3.0 ja 4.0, csv, Google Takeout, migratsioonitööriist
Kaks failivormingut, mida peaaegu kõik tunnevad
Kalendrid ja kontaktid viid üle kahes avatud vormingus:
- iCalendar, failid laiendiga
.ics(RFC 5545), kalendrite ja ülesannete jaoks. - vCard, failid laiendiga
.vcf, kontaktide jaoks. Vastu tuleb kaks versiooni: 3.0 (RFC 2426) ja 4.0 (RFC 6350).
Need on tavalised tekstifailid. Saad need avada tekstiredaktoris ja täpselt seda sa selles tunnis teedki. Kes teab, mida sees on, näeb ka, mida puudu on.
Sageli on eksportimisest lihtsam tee: paljudel uutel teenustel on migratsioonitööriist, mis sinu loal tõmbab otse Google'ist või Microsoftist su kalendrid ja kontaktid. See käib kiiremini ja vähemate vigadega. Siiski on mõistlik teha ka oma eksport: kontrolliks (kui palju mul kohtumisi ja kontakte oli?), varukoopiaks enne vana teenuse ülesütlemist ning väljapääsuks juhuks, kui su haldur ei luba migratsioonitööriista kasutada.
Nii näeb välja kalendrifail
Bakkerij De Korreli kalendri eksport algab nii:
BEGIN:VCALENDAR
VERSION:2.0
PRODID:-//Google Inc//Google Calendar 70.9054//EN
BEGIN:VTIMEZONE
TZID:Europe/Amsterdam
...
END:VTIMEZONE
BEGIN:VEVENT
UID:3f1a9c2e7b@google.com
DTSTART;TZID=Europe/Amsterdam:20261110T060000
DTEND;TZID=Europe/Amsterdam:20261110T070000
RRULE:FREQ=WEEKLY;BYDAY=TU
EXDATE;TZID=Europe/Amsterdam:20261229T060000
SUMMARY:Levering meel
ORGANIZER:mailto:anne@example.com
ATTENDEE;CN=Groothandel:mailto:verkoop@example.net
BEGIN:VALARM
TRIGGER:-PT30M
ACTION:DISPLAY
END:VALARM
END:VEVENT
END:VCALENDARMida sa näed:
| Rida | Tähendus | Kus võib viga tekkida |
|---|---|---|
BEGIN:VCALENDAR ja VERSION:2.0 | see on iCalendar-fail | kui see puudub, keeldub importimine |
BEGIN:VEVENT ... END:VEVENT | üks kohtumine | puuduv END teeb ülejäänu loetamatuks |
UID | kohtumise püsiv tunnus | ilma UID-ita ei suuda server duplikaate ära tunda |
DTSTART;TZID=... | algusaeg ajavööndis | vt ajavööndeid allpool |
RRULE | kordumisreegel: iga teisipäev | vigane reegel annab ühe kohtumise terve seeria asemel |
EXDATE | erand: sellel teisipäeval mitte | |
ORGANIZER, ATTENDEE | kes kutsus ja kes on kutsutud | vt kutseid allpool |
VALARM | meeldetuletus, 30 minutit ette | mitte iga teenus ei võta meeldetuletusi üle |
Ajavööndid
Aeg väärtusega TZID=Europe/Amsterdam tähendab: kell 6 hommikul Amsterdamis, ka pärast suveajale üleminekut. Fail peab seetõttu sisaldama ka plokki VTIMEZONE, mis seda ajavööndit kirjeldab. Outlooki eksport kasutab sageli Windowsi nimesid nagu W. Europe Standard Time. See toimib hästi, kuni VTIMEZONE-plokk on kaasas. Kui see puudub, arvab uus teenus ajavööndi ise ära ja kohtumised nihkuvad tund aega. Aeg, mis lõpeb tähega Z (20261110T050000Z), on UTC-s ja alati üheselt mõistetav. Aega ilma ajavööndita ja ilma Z-ta nimetatakse "hõljuvaks" ajaks: see kehtib selle ajavööndis, kes seda vaatab.
Kogu päeva kestvad kohtumised on kirjas kuupäevana ilma kellaajata: DTSTART;VALUE=DATE:20261224.
Kutsed
Kohtumine, mille sina korraldasid, on failis kirjas sinuga kui ORGANIZER. Pärast importimist seisab see sinu uues kalendris, aga osalejatel on see oma kalendris endiselt kutsena su vanalt aadressilt, koos vana teenuse UID-ga. Kui sa kohtumist hiljem muudad, saavad nemad uue kutse. Korduvate koosolekute puhul välispartneritega võib olla korrektsem kutsuda nad pärast üleminekut uuesti. Kohtumised, kuhu sind on kutsutud, tulevad kaasa tavalise kohtumisena; vastused korraldajale käivad meili kaudu.
Eksportimine Google'ist
- Kalender: Google kalendris, Seadistuste alt, osast Importimine ja eksportimine, nupust Eksportimine. Saad zip-faili, milles on ics-fail iga kalendri kohta, mille omanik sa oled. Kalendrid, mida teised sinuga jagavad, ei ole kaasas; neid eksportib omanik, või eksportid need ise iga kalendri seadetest, kui see on lubatud.
- Kontaktid: Google Kontaktides valid kontaktid (või kõik), valid Eksportimine ja seejärel vCard-vormingu. Google pakub ka "Google CSV" ja "Outlook CSV" valikut; vali vCard, see säilitab struktuuri (mitu telefoninumbrit, aadressid, foto).
- Kõik korraga: Google Takeout (takeout.google.com) annab kalendri ics-failina, kontaktid vcf-failina (või csv) ja Gmaili mbox-failina, zip-failides. Kasulik kogu konto varukoopiana.
Menüünimed muutuvad aeg-ajalt; kahtluse korral otsi Google'i abist "kalendri eksportimine".
Eksportimine Microsoftist
- Kalender: klassikalises Windowsi Outlookis saad kalendri salvestada iCalendar-failina (Salvesta nimega, koos perioodi ja "täielike üksikasjade" valikuga). Vali piisavalt pikk periood nii minevikku kui tulevikku ning vali täielikud üksikasjad, muidu eksportid ainult vaba/hõivatud teabe. Veebipõhises Outlookis saad kalendri avaldada ICS-lingina ja faili selle lingi kaudu alla laadida; lülita avaldamine hiljem uuesti välja.
- Kontaktid: veebipõhine Outlook eksportib kontaktid csv-vormingus, mitte vCard-ina. Ka klassikaline Outlook eksportib hulgi csv-vormingus; vCard saab seal teha ainult ühe kontakti kaupa. Paljud CardDAV-teenused ei suuda csv-faili otse importida. Kaks väljapääsu: kasuta oma uue teenuse migratsioonitööriista (see tõmbab kontaktid otse) või impordi csv Thunderbirdi aadressiraamatusse ja ekspordi sealt vCard-ina.
- Jagatud kalendrid ja ruumikalendrid on organisatsiooni kalendrid. Neid eksportib haldur, või seadistad need uues teenuses uuesti üles.
Mis eksportimisel kaasa ei tule või teisiti käitub
| Osa | Mis juhtub |
|---|---|
| Kohtumiste manused | enamasti ei tule kaasa; ainult link, või midagi ei jää |
| Värvid ja kategooriad | mõnikord kui CATEGORIES, sageli mitte |
| Meeldetuletused | mõnikord, sõltub teenusest |
| Videokoosoleku lingid (Teams, Meet) | jäävad kohtumisse tekstina, aga ei tööta enam pärast ülesütlemist |
| Kontaktgrupid või sildid | mitte alati; kontrolli pärast importimist |
| Kontaktide fotod | tulevad vCard-is kaasa, aga teevad faili suureks |
Loenda enne edasi minekut
Kirjuta enne eksportimist üles, mitu kontakti sul on ja, mõne kalendri puhul, mitu kohtumist jääb kindlasse perioodi (näiteks november). Pärast importimist loe uuesti üle. See on kiireim viis näha, kas midagi on puudu. Selle tunni ülesandes lased programmil su failid üle lugeda ja kontrollida.
Praktikas: nii näeb see välja ühel teenusepakkujal
WebOké Nextcloudis on kaks migratsioonitööriista, mis tõmbavad andmed otse: WebOké Import Tool Google'i jaoks (Drive, Fotod, Kalender ja Kontaktid) ning Andmemigratsioon OneDrive'i ja Microsoft 365 jaoks, millega impordid ka kontaktid ja kalendrid oma Microsofti kontost. Kui su kalender pärineb mujalt, impordid ics- ja vCard-failid ise (tund 5.3). Nextcloud loeb vCard 3.0 ja 4.0 vormingut. Teistel Euroopa teenustel on sarnased impordivahendid või impordinupp kalendris ja aadressiraamatus; failivormingud on kõikjal samad.
Kokkuvõte
- Kalendrid viid üle ics-failina (iCalendar), kontaktid vcf-failina (vCard 3.0 või 4.0); need on loetavad tekstifailid.
- Migratsioonitööriist, mis andmed otse tõmbab, on sageli lihtsam, aga tee ikkagi oma eksport kontrolliks ja varukoopiaks.
- Jälgi ics-failis UID-d, RRULE-t ja ajavööndeid koos VTIMEZONE-plokiga; ilma selleta nihkuvad kohtumised.
- Veebipõhine Outlook eksportib kontaktid ainult csv-vormingus; kasuta migratsioonitööriista või teisenda csv vCard-iks.
- Loenda enne kontaktid ja kohtumised, et pärast importimist näha, kas midagi on puudu.
Test
Ülesanne
Ülesanne A5.2: Kontrolli oma testeksporti. Ekspordi üks kalender (ics) ja oma kontaktid (vcf). Täida esmalt, mitu kontakti sul on ja mitu kohtumist sa ootad. Seejärel laadi failid üles. Programm kontrollib, kas need on kehtivad, loeb üle kohtumised, kordumised ja kontaktid, otsib ajavööndeid ilma kirjelduseta ja topeltkontakte ning võrdleb neid sinu antud arvudega. Failid ainult loetakse ja neid ei säilitata.
Ülesanne E5.2: Mis ei tule kaasa? Ava oma ics-fail tekstiredaktoris. Leia üks korduv kohtumine, üks kohtumine koos osalejatega ja üks kohtumine videokoosoleku lingiga. Märgi iga kohtumise juurde, mida pead pärast üleminekut tegema.
Ülesanne E5.2: Mis ei tule kaasa?
Ava oma ics-fail tekstiredaktoris.
Su linnukesed ja märkmed jäävad ainult sellesse brauserisse, me ei saada neid kuhugi. Kui oled sisse loginud, salvestame Minu kursustes ainult info, et tegid ülesande ära.
Lisalugemist
Nende artiklite sammud kehtivad WebOké teenuste kohta; teistel teenusepakkujatel toimib see sarnaselt.
- Nextcloudi juhend 13.5: Kalendri ja kontaktide ülekandmine Google'ist, iCloudist või Outlookist (ics ja vCard)
- Nextcloudi juhend 13.2: Google Drive, Fotod, Kalender ja Kontaktid üleviimine WebOké Import Tool'iga
- Nextcloudi juhend 13.4: OneDrive ülekandmine andmerände abil
- Nextcloudi juhend 13.6: Microsoft 365-lt WebOké-sse: failid, dokumendid, e-post ja kalender
- RFC 5545 (iCalendar), RFC 2426 (vCard 3.0), RFC 6350 (vCard 4.0)
- Google Kalendri abi: Sündmuste eksportimine; Google Kontaktide abi: Kontaktide eksportimine; Microsofti tugi: Kontaktide eksportimine Outlookist
